# vim: ft=python fileencoding=utf-8 sts=4 sw=4 et:

# Copyright 2015-2017 Florian Bruhin (The Compiler) <mail@qutebrowser.org>:
#
# This file is part of qutebrowser.
#
# qutebrowser is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# qutebrowser is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with qutebrowser.  If not, see <http://www.gnu.org/licenses/>.

"""pytest fixtures for tests.keyinput."""

import pytest


BINDINGS = {'prompt': {'<Ctrl-a>': 'message-info ctrla',
                       'a': 'message-info a',
                       'ba': 'message-info ba',
                       'ax': 'message-info ax',
                       'ccc': 'message-info ccc',
                       '0': 'message-info 0'},
            'command': {'foo': 'message-info bar',
                        '<Ctrl+X>': 'message-info ctrlx'},
            'normal': {'a': 'message-info a', 'ba': 'message-info ba'}}


@pytest.fixture
def keyinput_bindings(config_stub, key_config_stub):
    """Register some test bindings."""
    config_stub.val.bindings.default = {}
    config_stub.val.bindings.commands = dict(BINDINGS)
